
Redmine - Defect #2111

Hook issue in some places of redmine

2008-10-30 12:34 - Diego Sousa

Status: Closed Start date: 2008-10-30

Priority: Normal Due date:  

Assignee: Eric Davis % Done: 100%

Category: Plugin API Estimated time: 0.00 hour

Target version: 0.8   

Resolution: Fixed Affected version:  

Description

I'm with a problem with hook api, i made a plugin to make time_entry accept other fields like start hour, end hour and break time

instead only hours, in the issue view, the hook works very nice in view and in controller, than i was trying to change in time log too,

the view works fine, but when i put the hook in controller i get a error, i all ready tried to call a empty hook call_hook() and i get

error....

@Processing TimelogController#edit (for 127.0.0.1 at 2008-10-30 09:39:31) [GET]

Session ID: f71a27b45be5f23aeb42c0cb88dc20b4

Parameters: {"action"=>"edit", "issue_id"=>"2", "controller"=>"timelog"}

SQL (0.000366)   SELECT max("settings".updated_on) AS max_updated_on FROM "settings"

User Load (0.001245)   SELECT * FROM "users" WHERE ("users"."id" = 3) AND (status = 1)

Issue Load (0.001157)   SELECT * FROM "issues" WHERE ("issues"."id" = 2)

Project Load (0.000951)   SELECT * FROM "projects" WHERE ("projects"."id" = 2)

EnabledModule Load (0.001991)   SELECT * FROM "enabled_modules" WHERE ("enabled_modules".project_id = 2)

NoMethodError (undefined method `call_hook' for #<TimelogController:0xb499caf0>):

/app/controllers/timelog_controller.rb:192:in `edit'

/usr/lib/ruby/gems/1.8/gems/actionpack-2.1.0/lib/action_controller/base.rb:1162:in `send'

/usr/lib/ruby/gems/1.8/gems/actionpack-2.1.0/lib/action_controller/base.rb:1162:in `perform_action_without_filters'

/usr/lib/ruby/gems/1.8/gems/actionpack-2.1.0/lib/action_controller/filters.rb:580:in `call_filters'

/usr/lib/ruby/gems/1.8/gems/actionpack-2.1.0/lib/action_controller/filters.rb:573:in `perform_action_without_benchmark'

/usr/lib/ruby/gems/1.8/gems/actionpack-2.1.0/lib/action_controller/benchmarking.rb:68:in `perform_action_without_rescue'

/usr/lib/ruby/1.8/benchmark.rb:293:in `measure'

/usr/lib/ruby/gems/1.8/gems/actionpack-2.1.0/lib/action_controller/benchmarking.rb:68:in `perform_action_without_rescue'

/usr/lib/ruby/gems/1.8/gems/actionpack-2.1.0/lib/action_controller/rescue.rb:201:in `perform_action_without_caching'

/usr/lib/ruby/gems/1.8/gems/actionpack-2.1.0/lib/action_controller/caching/sql_cache.rb:13:in `perform_action'

/usr/lib/ruby/gems/1.8/gems/activerecord-2.1.0/lib/active_record/connection_adapters/abstract/query_cache.rb:33:in `cache'

/usr/lib/ruby/gems/1.8/gems/activerecord-2.1.0/lib/active_record/query_cache.rb:8:in `cache'

/usr/lib/ruby/gems/1.8/gems/actionpack-2.1.0/lib/action_controller/caching/sql_cache.rb:12:in `perform_action'

/usr/lib/ruby/gems/1.8/gems/actionpack-2.1.0/lib/action_controller/base.rb:529:in `send'

/usr/lib/ruby/gems/1.8/gems/actionpack-2.1.0/lib/action_controller/base.rb:529:in `process_without_filters'

/usr/lib/ruby/gems/1.8/gems/actionpack-2.1.0/lib/action_controller/filters.rb:569:in `process_without_session_management_support'

/usr/lib/ruby/gems/1.8/gems/actionpack-2.1.0/lib/action_controller/session_management.rb:130:in `process'

/usr/lib/ruby/gems/1.8/gems/actionpack-2.1.0/lib/action_controller/base.rb:389:in `process'

/usr/lib/ruby/gems/1.8/gems/actionpack-2.1.0/lib/action_controller/dispatcher.rb:149:in `handle_request'

/usr/lib/ruby/gems/1.8/gems/actionpack-2.1.0/lib/action_controller/dispatcher.rb:107:in `dispatch'

/usr/lib/ruby/gems/1.8/gems/actionpack-2.1.0/lib/action_controller/dispatcher.rb:104:in `synchronize'

/usr/lib/ruby/gems/1.8/gems/actionpack-2.1.0/lib/action_controller/dispatcher.rb:104:in `dispatch'

/usr/lib/ruby/gems/1.8/gems/actionpack-2.1.0/lib/action_controller/dispatcher.rb:120:in `dispatch_cgi'

/usr/lib/ruby/gems/1.8/gems/actionpack-2.1.0/lib/action_controller/dispatcher.rb:35:in `dispatch'

/usr/lib/ruby/gems/1.8/gems/mongrel-1.1.5/bin/../lib/mongrel/rails.rb:76:in `process'

/usr/lib/ruby/gems/1.8/gems/mongrel-1.1.5/bin/../lib/mongrel/rails.rb:74:in `synchronize'

/usr/lib/ruby/gems/1.8/gems/mongrel-1.1.5/bin/../lib/mongrel/rails.rb:74:in `process'

/usr/lib/ruby/gems/1.8/gems/mongrel-1.1.5/lib/mongrel.rb:159:in `process_client'

/usr/lib/ruby/gems/1.8/gems/mongrel-1.1.5/lib/mongrel.rb:158:in `each'

/usr/lib/ruby/gems/1.8/gems/mongrel-1.1.5/lib/mongrel.rb:158:in `process_client'

/usr/lib/ruby/gems/1.8/gems/mongrel-1.1.5/lib/mongrel.rb:285:in `run'

/usr/lib/ruby/gems/1.8/gems/mongrel-1.1.5/lib/mongrel.rb:285:in `initialize'

/usr/lib/ruby/gems/1.8/gems/mongrel-1.1.5/lib/mongrel.rb:285:in `new'

/usr/lib/ruby/gems/1.8/gems/mongrel-1.1.5/lib/mongrel.rb:285:in `run'

/usr/lib/ruby/gems/1.8/gems/mongrel-1.1.5/lib/mongrel.rb:268:in `initialize'

/usr/lib/ruby/gems/1.8/gems/mongrel-1.1.5/lib/mongrel.rb:268:in `new'
/usr/lib/ruby/gems/1.8/gems/mongrel-1.1.5/lib/mongrel.rb:268:in `run'

/usr/lib/ruby/gems/1.8/gems/mongrel-1.1.5/lib/mongrel/configurator.rb:282:in `run'

/usr/lib/ruby/gems/1.8/gems/mongrel-1.1.5/lib/mongrel/configurator.rb:281:in `each'

/usr/lib/ruby/gems/1.8/gems/mongrel-1.1.5/lib/mongrel/configurator.rb:281:in `run'

/usr/lib/ruby/gems/1.8/gems/mongrel-1.1.5/bin/mongrel_rails:128:in `run'

/usr/lib/ruby/gems/1.8/gems/mongrel-1.1.5/lib/mongrel/command.rb:212:in `run'

/usr/lib/ruby/gems/1.8/gems/mongrel-1.1.5/bin/mongrel_rails:281

/usr/lib/ruby/gems/1.8/gems/activesupport-2.1.0/lib/active_support/dependencies.rb:502:in `load'

/usr/lib/ruby/gems/1.8/gems/activesupport-2.1.0/lib/active_support/dependencies.rb:502:in `load'

/usr/lib/ruby/gems/1.8/gems/activesupport-2.1.0/lib/active_support/dependencies.rb:354:in `new_constants_in'

/usr/lib/ruby/gems/1.8/gems/activesupport-2.1.0/lib/active_support/dependencies.rb:502:in `load'

/usr/lib/ruby/gems/1.8/gems/rails-2.1.0/lib/commands/servers/mongrel.rb:64

/usr/local/lib/site_ruby/1.8/rubygems/custom_require.rb:27:in `gem_original_require'

/usr/local/lib/site_ruby/1.8/rubygems/custom_require.rb:27:in `require'

/usr/lib/ruby/gems/1.8/gems/activesupport-2.1.0/lib/active_support/dependencies.rb:509:in `require'

/usr/lib/ruby/gems/1.8/gems/activesupport-2.1.0/lib/active_support/dependencies.rb:354:in `new_constants_in'

/usr/lib/ruby/gems/1.8/gems/activesupport-2.1.0/lib/active_support/dependencies.rb:509:in `require'

/usr/lib/ruby/gems/1.8/gems/rails-2.1.0/lib/commands/server.rb:39

/usr/local/lib/site_ruby/1.8/rubygems/custom_require.rb:27:in `gem_original_require'

/usr/local/lib/site_ruby/1.8/rubygems/custom_require.rb:27:in `require'

script/server:3

Rendering /usr/lib/ruby/gems/1.8/gems/actionpack-2.1.0/lib/action_controller/templates/rescues/layout.erb (internal_server_error)

@

Associated revisions

Revision 1979 - 2008-11-06 06:37 - Eric Davis

Included Redmine::Hook::Helper to ActionController::Base so call_hook

is available in all controllers. #2111

History

#1 - 2008-10-30 13:43 - Diego Sousa

i found the problem, in IssuesController i dont get error because of mixin with IssuesHelper and inside IssuesHelper have a mixin with

ApplicationHelper that include the Redmine::Hook::Helper that have the method call_hook, TimelogController has a mixin too with TimelogHelper but

TimelogHelper dont have a mixin with ApplicationHelper, well instead of mixin every helper i changed the hook.rb file lib/redmine/hook.rb in the last

line i add ActionController::Base.send(:include, Redmine::Hook::Helper) now all the controllers have the call_hook method.

#2 - 2008-10-30 16:38 - Eric Davis

- Category set to Plugin API

- Status changed from New to 7

- Assignee set to Eric Davis

- Affected version (unused) set to devel

Good research, I knew somewhere the Redmine::Hook::Helper wasn't getting mixed in but I didn't have the time to debug it.  I should be able to

create a fix for this soon.

#3 - 2008-11-06 06:39 - Eric Davis

- Status changed from 7 to Resolved

- Target version set to 0.8

- % Done changed from 0 to 100

- Resolution set to Fixed

Redmine::Hook::Helper is now included in ActionController::Base so call_hook is available in all controllers.  Thank you for your bug report and the

research.  r1979

#4 - 2008-11-11 16:09 - Jean-Philippe Lang

- Status changed from Resolved to Closed

Closing this ticket since it seems to be fixed.
